.386
.model flat,stdcall
option casemap:none

include ASM-USBrelay.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc uses esi hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	;
	;
	;	NOTE: This is a very basic example of calling functions from the USBrelay_DLL.dll in Win32 ASM.
	;	Normally you would include sanity checking and error handlers.
	;
	;

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		;show relay icon on window
		invoke LoadIcon,hInstance,700
		invoke SendMessage, hWin, WM_SETICON, TRUE, eax
			
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		
		.if eax==TESTDLL_BTN
			invoke TestDLL, ADDR buffer ; test if DLL present
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR buffer,ADDR CRLF
			
		.elseif eax==FINDUSBRELAY_BTN
			invoke FindUSBrelayBoards, ADDR buffer ; find attached USB relay boards
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke szCopy,ADDR buffer, ADDR FoundUSBrelay
			lea esi,FoundUSBrelay
			mov eax,0
			mov [esi+4],al ; strip seperator
			invoke AppendText,hWnd,TEXTBOX,ADDR FoundUSBrelay,ADDR CRLF
			;get board info
			invoke htodw,ADDR FoundUSBrelay
			mov Pid,eax
			invoke ReadUSBrelays, Pid, ADDR buffer ; read relay status
			lea esi,buffer
			
			;LED STATUS
			mov al,[esi+6]
			mov LedStatus,al
			;Relay 1 LED
			mov al,LedStatus
			and al,1
			.if al==1
				invoke SendDlgItemMessage, hWnd, 1019, BM_SETCHECK, 1, 0
			.endif
			;Relay 2 LED
			mov al,LedStatus
			and al,2
			.if al==2
				invoke SendDlgItemMessage, hWnd, 1020, BM_SETCHECK, 1, 0
			.endif
			;Relay 3 LED
			mov al,LedStatus
			and al,4
			.if al==4
				invoke SendDlgItemMessage, hWnd, 1021, BM_SETCHECK, 1, 0
			.endif
			;Relay 4 LED
			mov al,LedStatus
			and al,8
			.if al==8
				invoke SendDlgItemMessage, hWnd, 1022, BM_SETCHECK, 1, 0
			.endif
			;Relay 5 LED
			mov al,LedStatus
			and al,16
			.if al==16
				invoke SendDlgItemMessage, hWnd, 1023, BM_SETCHECK, 1, 0
			.endif
			;Heart Beat LED
			mov al,LedStatus
			and al,32
			.if al==32
				invoke SendDlgItemMessage, hWnd, 1024, BM_SETCHECK, 1, 0
			.endif
			
			;Firmware Version
			mov al,[esi+7]
			mov FirmwareVersion,al
			mov al,[esi+8]
			mov FirmwareVersion+1,al
			mov al,[esi+9]
			mov FirmwareVersion+2,al
			mov al,[esi+10]
			mov FirmwareVersion+3,al
			mov al,0
			mov FirmwareVersion+4,al
			invoke SetDlgItemText,hWnd,1026,ADDR FirmwareVersion
			
			;enable buttons
			invoke GetDlgItem,hWnd,GETMANUFACTURERSTRING_BTN
			invoke EnableWindow,eax,TRUE ; enable GETMANUFACTURERSTRING_BTN	
			invoke GetDlgItem,hWnd,GETPRODUCTSTRING_BTN
			invoke EnableWindow,eax,TRUE ; enable GETPRODUCTSTRING_BTN	
			invoke GetDlgItem,hWnd,GETVERSIONSTRING_BTN
			invoke EnableWindow,eax,TRUE ; enable GETVERSIONSTRING_BTN
			invoke GetDlgItem,hWnd,RELAY1_ON_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY1_ON_BTN
			invoke GetDlgItem,hWnd,RELAY1_OFF_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY1_OFF_BTN
			
			invoke GetDlgItem,hWnd,RELAY2_ON_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY2_ON_BTN
			invoke GetDlgItem,hWnd,RELAY2_OFF_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY2_OFF_BTN
			
			invoke GetDlgItem,hWnd,RELAY3_ON_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY3_ON_BTN
			invoke GetDlgItem,hWnd,RELAY3_OFF_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY3_OFF_BTN
			
			invoke GetDlgItem,hWnd,RELAY4_ON_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY4_ON_BTN
			invoke GetDlgItem,hWnd,RELAY4_OFF_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY4_OFF_BTN
			
			invoke GetDlgItem,hWnd,RELAY5_ON_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY5_ON_BTN
			invoke GetDlgItem,hWnd,RELAY5_OFF_BTN
			invoke EnableWindow,eax,TRUE ; enable RELAY5_OFF_BTN
		
		.elseif eax==GETMANUFACTURERSTRING_BTN	
			invoke GetManufacturerString,Pid,ADDR buffer			;call function from DLL
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR buffer,ADDR CRLF	;Append it to the Text Box
		
		.elseif eax==GETPRODUCTSTRING_BTN
			invoke GetProductString,Pid,ADDR buffer					;call function from DLL
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR buffer,ADDR CRLF
		
		.elseif eax==GETVERSIONSTRING_BTN
			invoke GetVersionString,Pid,ADDR buffer					;call function from DLL
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR buffer,ADDR CRLF
		
		.elseif eax==RELAY1_ON_BTN
			invoke WriteUSBrelay,Pid,1,0 ;Relay 1 Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay1_ON_string,ADDR CRLF
			
		.elseif eax==RELAY1_OFF_BTN
			invoke WriteUSBrelay,Pid,0,0 ;Relay 1 De-Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay1_OFF_string,ADDR CRLF
		
		.elseif eax==RELAY2_ON_BTN
			invoke WriteUSBrelay,Pid,3,0 ;Relay 2 Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay2_ON_string,ADDR CRLF
			
		.elseif eax==RELAY2_OFF_BTN
			invoke WriteUSBrelay,Pid,2,0 ;Relay 2 De-Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay2_OFF_string,ADDR CRLF	
			

		.elseif eax==RELAY3_ON_BTN
			invoke WriteUSBrelay,Pid,5,0 ;Relay 3 Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay3_ON_string,ADDR CRLF
			
		.elseif eax==RELAY3_OFF_BTN
			invoke WriteUSBrelay,Pid,4,0 ;Relay 3 De-Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay3_OFF_string,ADDR CRLF	
			
			
		.elseif eax==RELAY4_ON_BTN
			invoke WriteUSBrelay,Pid,7,0 ;Relay 4 Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay4_ON_string,ADDR CRLF
			
		.elseif eax==RELAY4_OFF_BTN
			invoke WriteUSBrelay,Pid,6,0 ;Relay 4 De-Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay4_OFF_string,ADDR CRLF				
			
			
		.elseif eax==RELAY5_ON_BTN
			invoke WriteUSBrelay,Pid,9,0 ;Relay 5 Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay5_ON_string,ADDR CRLF
			
		.elseif eax==RELAY5_OFF_BTN
			invoke WriteUSBrelay,Pid,8,0 ;Relay 5 De-Energized
			.if eax==0
				;error occured
				;handle it here
			.endif
			invoke AppendText,hWnd,TEXTBOX,ADDR Relay5_OFF_string,ADDR CRLF				
			
			
			
		.elseif eax==SAVE_BTN	
			
				mov al,0
				mov TempLedStatus,al
				
				;Relay 1 LED
				invoke IsDlgButtonChecked, hWnd, 1019 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,1
  					mov TempLedStatus,al
				.endif
				
				;Relay 2 LED
				invoke IsDlgButtonChecked, hWnd, 1020 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,2
  					mov TempLedStatus,al
				.endif
				
				;Relay 3 LED
				invoke IsDlgButtonChecked, hWnd, 1021 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,4
  					mov TempLedStatus,al
				.endif
				
				;Relay 4 LED
				invoke IsDlgButtonChecked, hWnd, 1022 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,8
  					mov TempLedStatus,al
				.endif
				
				;Relay 5 LED
				invoke IsDlgButtonChecked, hWnd, 1023 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,16
  					mov TempLedStatus,al
				.endif
				
				;Heart Beat LED
				invoke IsDlgButtonChecked, hWnd, 1024 
				.if eax==TRUE
  					mov al,TempLedStatus
  					or al,32
  					mov TempLedStatus,al
				.endif
				
				mov al,TempLedStatus
				invoke WriteUSBrelay,Pid,11,eax ;Send LED status
				invoke AppendText,hWnd,TEXTBOX,ADDR Leds_Saved_string,ADDR CRLF	
				
			
			
			
							
		
		.elseif eax==ABOUT_BTN
			invoke MessageBox,hWnd,ADDR AboutMsg,ADDR AppName,MB_OK
		
		.elseif eax==EXIT_BTN
			invoke SendMessage,hWin,WM_CLOSE,0,0
				
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

; ########################################################################
; Append Text Procedure
; ########################################################################
AppendText proc dwhWnd:DWORD, ctrlid:DWORD, lpBuffer:DWORD, lpCRLF:DWORD
  invoke SendDlgItemMessage,dwhWnd,ctrlid,EM_SETSEL,0,-1
  invoke SendDlgItemMessage,dwhWnd,ctrlid,EM_SETSEL,-1,0
  invoke SendDlgItemMessage,dwhWnd,ctrlid,EM_REPLACESEL,FALSE,lpBuffer
  invoke SendDlgItemMessage,dwhWnd,ctrlid,EM_REPLACESEL,0,lpCRLF
  ret
AppendText endp

end start
